api/administration/urls.py
from django.contrib.auth import views
from django.contrib.auth.decorators import login_required
from django.urls import path
from rest_framework import routers
from django.urls import include, path
from . import views as admin_views
from .services.order_view import OrderView
from .services.aggregator_view import AggregatorView
from .services.store_view import StoreView
from .services.menu_view import MenuView
from .forms import UserLoginForm

# router = routers.DefaultRouter()
# router.register(r'aggregator', AggregatorView, basename='aggregator')
# router.register(r'store', StoreView, basename='store')
# router.register(r'menu', MenuView, basename='menu')
# router.register(r'order', OrderView, basename='order')

urlpatterns = [
    path('index', login_required(admin_views.index_view), name="index"),
    path('login', views.LoginView.as_view(template_name="app/login.html", authentication_form=UserLoginForm),
         name='login'),
    path('logout', login_required(admin_views.logout_view), name='logout'),
    # path('', include(router.urls)),
    path('user', login_required(admin_views.user_list), name="user_list"),
    path('user/add', login_required(admin_views.user_add), name="user_add"),
    path('user/edit/<str:id>', login_required(admin_views.user_edit), name="user_edit"),
    path('store/add', login_required(admin_views.store_add), name="store_add"),
    path('store/edit/<str:id>', login_required(admin_views.store_edit), name="store_edit"),
    path('store/detail/<str:id>', login_required(admin_views.store_detail), name="store_detail"),
    path('aggregator/add', login_required(admin_views.aggregator_add), name="aggregator_add"),
    path('aggregator/edit/<str:id_pk>', login_required(admin_views.aggregator_edit), name="aggregator_edit"),
    path('aggregator', login_required(admin_views.aggregators_list), name="aggregators_list"),
    path('menu', login_required(admin_views.menus_list), name="menus_list"),
    path('menu/detail/<str:id>', login_required(admin_views.menu_detail), name="menu_detail"),
    path('order', login_required(admin_views.orders_list), name="orders_list"),
    path('order/canceled', login_required(admin_views.orders_canceled_list), name="orders_canceled_list"),
    path('order/not_received', login_required(admin_views.orders_not_received_list), name="orders_not_received_list"),
]

api/api/urls.py
from django.contrib import admin
from django.urls import path, include, re_path
from drf_yasg import openapi
from drf_yasg.views import get_schema_view
from rest_framework import permissions


schema_view = get_schema_view(
    openapi.Info(
        title="API",
        default_version='v1',
        description="API for interaction between Pixel and the aggregators"
    ),
    public=True,
    permission_classes=(permissions.AllowAny,),
)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/menu-app/', include(('menu.urls', 'menu'), namespace='menu')),
    path('api/order-app/', include(('order.urls', 'order'), namespace='order')),
    path('api/store-app/', include(('store.urls', 'store'), namespace='store')),
    path('', include(('administration.urls', 'administration'), namespace='administration')),
    re_path(r'^doc(?P<format>\.json|\.yaml)$', schema_view.without_ui(cache_timeout=0), name='schema-json'),
    path('doc/', schema_view.with_ui('swagger', cache_timeout=0), name='schema-swagger-ui'),
    path('redoc/', schema_view.with_ui('redoc', cache_timeout=0), name='schema-redoc'),
    # path('accounts/', include('django.contrib.auth.urls')),
    # path('api/auth/', include('djoser.urls.authtoken')),
]

api/store/urls.py
from django.urls import include, path
from rest_framework import routers

from . import views

router = routers.DefaultRouter()
router.register(r'', views.StoreViewSet)

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))
]

api/administration/models.py
from __future__ import unicode_literals

from django.db import models

# Create your models here.

api/store/forms.py
from django.forms import ModelForm

from .models import Store


class StoreForm(ModelForm):
    class Meta:
        model = Store
        fields = ['*']

api/administration/views.py
import json
from datetime import datetime, timedelta

from django.contrib.auth import get_user_model
from django.contrib.auth import logout
from django.db.models import Q
from django.shortcuts import redirect
from django.shortcuts import render
from menu.models import Menu
from order.models import Order, OrderNotReceived
from order.notifications_templates import *
from rest_framework import status
from store.dicts import dict_status_rappi, dict_status_pixel, dict_status_final, dict_mode
from store.enum import OrderStatusFinalEnum
from store.models import Store, Aggregator, StoreAggregator, Token

from .bad_request import BadRequest
from .error_type import ErrorType
from .forms import CustomUserCreationForm, CustomUserEditionForm
from .request_error import RequestError
from .serializers import StoreSerializer, AggregatorSerializer


def index_view(request):
    """
    Render to list of Stores
    """
    context = {'stores': get_stores_data()}
    return render(request, "store/store_list.html", context)


def get_aggregators_string(aggregators: []):
    aggregators_concat = ''
    for aggregator in aggregators:
        aggregators_concat = aggregators_concat + ', ' + aggregator
    return aggregators_concat[1:]


def get_stores_data():
    stores_data_list = []
    stores = Store.objects.all().order_by('name')
    for store in stores:
        aggregators_names = get_aggregators_string(store.aggregator.values_list('name', flat=True))
        stores_data_list.append({'id': store.id_pk,
                                 'integrationId': store.integrationId,
                                 'name': store.name,
                                 'active': store.active,
                                 'production_mode': store.production_mode,
                                 'develop_mode': store.develop_mode,
                                 'aggregators': aggregators_names})
    return stores_data_list


def get_aggregators_data():
    aggregators = Aggregator.objects.all().order_by('name')
    context = {'aggregators': aggregators}
    return context


def store_add(request):
    """
    Allows add or edit a Store
    """
    if request.method == 'POST':
        if not request.POST.get('ruc'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR, message=INSERT_STORE_WITHOUT_RUC))

        if not request.POST.get('stablishment_number'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=INSERT_STORE_WITHOUT_STABLISHMENT_NUMBER))

        integrationId = request.POST.get('ruc') + '-' + request.POST.get('stablishment_number')
        if integrationId and Store.objects.filter(integrationId=integrationId):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=ALREADY_EXIST_STORE_ID.format(integrationId)))

        store_data = {'integrationId': integrationId,
                      'name': request.POST.get('name'),
                      'active': True if request.POST.get('active') else False,
                      'production_mode': True if request.POST.get('active-production-mode') else False,
                      'develop_mode': True if request.POST.get('active-develop-mode') else False}

        store_serializer = StoreSerializer(data=store_data)

        if store_serializer.is_valid():
            store = store_serializer.save()

            aggregators_selected = request.POST.getlist('aggregators', [])
            store_aggregator_list = []
            for aggregator_id in aggregators_selected:
                aggregator_inserted = Aggregator.objects.get(id_pk=aggregator_id)

                relation_id = request.POST.get(aggregator_inserted.name) if request.POST.get(
                    aggregator_inserted.name) else None
                production_credentials = request.POST.get('production-credentials-' + aggregator_inserted.name)
                develop_credentials = request.POST.get('develop-credentials-' + aggregator_inserted.name)

                # prod_cred_dict = {}
                # dev_cred_dict = {}
                try:
                    prod_cred_dict = json.loads(production_credentials) if production_credentials else None
                except:
                    return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                      exception=RequestError(error_type=ErrorType.ERROR,
                                                             message=ERROR_CREDENTIALS.format('producción')))

                try:
                    dev_cred_dict = json.loads(develop_credentials) if develop_credentials else None
                except:
                    return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                      exception=RequestError(error_type=ErrorType.ERROR,
                                                             message=ERROR_CREDENTIALS.format('desarrollo')))

                store_aggregator = StoreAggregator(store=store, aggregator=aggregator_inserted,
                                                   relation_id=relation_id,
                                                   production_credentials=prod_cred_dict,
                                                   develop_credentials=dev_cred_dict)

                store_aggregator_list.append(store_aggregator)

            StoreAggregator.objects.bulk_create(store_aggregator_list)

        else:
            return BadRequest(http_status_code=status.HTTP_409_CONFLICT,
                              exception=RequestError(error_type=ErrorType.ERROR, message=CANT_INSERT_STORE))

        context = {'stores': get_stores_data()}
        return render(request, 'store/store_list.html', context)

    elif request.method == 'GET':
        context = {'create': True,
                   'aggregators': Aggregator.objects.all().order_by('name')}

        return render(request, 'store/store_form.html', context)


def store_edit(request, id):
    context = {}
    try:
        store = Store.objects.get(id_pk=id)
    except:
        error_mssg = NOT_EXIST_STORE_ID.format(id)
        return BadRequest(http_status_code=status.HTTP_404_NOT_FOUND,
                          exception=RequestError(error_type=ErrorType.ERROR, message=error_mssg))

    if request.method == 'POST':
        if not request.POST.get('ruc'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR, message=EDIT_STORE_WITHOUT_RUC))

        if not request.POST.get('stablishment_number'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=EDIT_STORE_WITHOUT_STABLISHMENT_NUMBER))

        new_integration_id = request.POST.get('ruc') + '-' + request.POST.get('stablishment_number')
        if new_integration_id and Store.objects.filter(~Q(id_pk=id), integrationId=new_integration_id):
            error_mssg = ALREADY_EXIST_STORE_ID.format(new_integration_id)
            return BadRequest(http_status_code=status.HTTP_409_CONFLICT,
                              exception=RequestError(error_type=ErrorType.ERROR, message=error_mssg))

        store_data = {'integrationId': new_integration_id,
                      'name': request.POST.get('name'),
                      'active': True if request.POST.get('active') else False,
                      'production_mode': True if request.POST.get('active-production-mode') else False,
                      'develop_mode': True if request.POST.get('active-develop-mode') else False}

        if new_integration_id:
            store, _ = Store.objects.update_or_create(id_pk=id, defaults=store_data)

        if store:
            Token.objects.filter(id=id).delete()

            aggregators_selected = request.POST.getlist('aggregators', [])

            store_aggregator_list = []
            for aggregator_id in aggregators_selected:
                try:
                    aggregator_inserted = Aggregator.objects.get(id_pk=aggregator_id)

                    relation_id = request.POST.get(aggregator_inserted.name) if request.POST.get(
                        aggregator_inserted.name) else None
                    production_credentials = request.POST.get('production-credentials-' + aggregator_inserted.name)
                    develop_credentials = request.POST.get('develop-credentials-' + aggregator_inserted.name)

                    try:
                        prod_cred_dict = json.loads(production_credentials) if production_credentials else None
                    except:
                        return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                          exception=RequestError(error_type=ErrorType.ERROR,
                                                                 message=ERROR_CREDENTIALS.format('producción')))

                    try:
                        dev_cred_dict = json.loads(develop_credentials) if develop_credentials else None
                    except:
                        return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                          exception=RequestError(error_type=ErrorType.ERROR,
                                                                 message=ERROR_CREDENTIALS.format('desarrollo')))

                    store_aggregator = StoreAggregator(store=store, aggregator=aggregator_inserted,
                                                       relation_id=relation_id,

api/store/controllers/aggregator_controller.py
from ..enum import TraceTypeEnum, ModeEnum
from ..models import Aggregator
from ..utils import insert_trace


class AggregatorController:

    def get_aggregator_by_name(self, aggregator_name, trace_type, mode):
        try:
            return Aggregator.objects.get(name=aggregator_name)
        except Exception as e:
            insert_trace(trace_type=trace_type.value,
                         instance_id=aggregator_name,
                         exception=str(e),
                         mode=mode.value)
            return None


    def get_base_url_by_mode(self, mode, aggregator, instace_id, trace_type):
        base_url = None
        if mode == ModeEnum.DEVELOP:
            if not aggregator.develop_url:
                exception = "Aggregator with name {} not have develop_url".format(aggregator.name)
                insert_trace(trace_type=trace_type.value,
                             exception=exception,
                             instance_id=instace_id,
                             mode=mode.value)
            else:
                base_url = aggregator.develop_url
        else:
            if not aggregator.production_url:
                exception = "Aggregator with name {} not have production_url".format(aggregator.name)
                insert_trace(trace_type=trace_type.value,
                             exception=exception,
                             instance_id=instace_id,
                             mode=mode.value)
            else:
                base_url = aggregator.production_url
        return base_url

api/administration/templates/store/store_form.html
{% extends "app/base_site.html" %}

{% block title %} Registrar tienda {% endblock %}

{% block content %}
    <div class="right_col" role="main">
        <div class="">
            <div class="clearfix"></div>
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>{% if create %} Registro {% else %} Edición {% endif %}de tienda</h2>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <br/>
                            <form id="form-add-store" data-parsley-validate class="form-horizontal form-label-left"
                                  method="post" action="
{% if create %}
{% url 'administration:store_add' %}
{% else %}
{% url 'administration:store_edit' store.id_pk %}
{% endif %}
">
                                {% csrf_token %}

                                <div class="form-group">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12" for="input-name">Nombre
                                        comercial
                                        <span class="required">*</span>
                                    </label>
                                    <div class="col-md-6 col-sm-6 col-xs-12">
                                        <input type="text" id="input-name" required="required"
                                               name="name"
                                                {% if not create %}
                                               value="{{ store.name }}"
                                                {% endif %}
                                               class="form-control col-md-7 col-xs-12">
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12" for="input-ruc">RUC
                                        <span class="required">*</span>
                                    </label>
                                    <div class="col-md-6 col-sm-6 col-xs-12">
                                        <input type="text" id="input-ruc" required="required"
                                               name="ruc"
                                                {% if not create %}
                                               value="{{ ruc }}"
                                                {% endif %}
                                               class="form-control col-md-7 col-xs-12">
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12"
                                           for="input-stablishment-number">
                                        Número de establecimiento
                                        <span class="required">*</span>
                                    </label>
                                    <div class="col-md-6 col-sm-6 col-xs-12">
                                        <input type="text" id="input-stablishment-number"
                                               required="required"
                                               name="stablishment_number"
                                                {% if not create %}
                                               value="{{ stablishment_number }}"
                                                {% endif %}
                                               class="form-control col-md-7 col-xs-12">
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 col-sm-3 col-xs-12 control-label">Disponibilidad</label>
                                    <div class="col-md-9 col-sm-9 col-xs-12">
                                        <div class="checkbox">
                                            <label>
                                                <input type="checkbox" name="active"
                                                       value="active"
                                                        {% if create %}
                                                       checked
                                                        {% else %}
                                                            {% if store.active %}
                                                       checked
                                                            {% endif %}
                                                        {% endif %}>
                                            </label>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 col-sm-3 col-xs-12 control-label">Modo Producción</label>
                                    <div class="col-md-9 col-sm-9 col-xs-12">
                                        <div class="checkbox">
                                            <label>
                                                <input type="checkbox" name="active-production-mode"
                                                       value="active"
                                                        {% if create %}
                                                       checked
                                                        {% else %}
                                                            {% if store.production_mode %}
                                                       checked
                                                            {% endif %}
                                                        {% endif %}>
                                            </label>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 col-sm-3 col-xs-12 control-label">Modo Desarrollo</label>
                                    <div class="col-md-9 col-sm-9 col-xs-12">
                                        <div class="checkbox">
                                            <label>
                                                <input type="checkbox" name="active-develop-mode"
                                                       value="active"
                                                        {% if create %}
                                                       checked
                                                        {% else %}
                                                            {% if store.develop_mode %}
                                                       checked
                                                            {% endif %}
                                                        {% endif %}>
                                            </label>
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                        Agregadores
                                    </label>
                                </div>

                                {% for aggregator in aggregators %}
                                    <div class="form-group row">
                                        <label class="col-md-3 col-sm-3  control-label">
                                            {{ aggregator.name }}
                                        </label>
                                        <div class="col-md-9 col-sm-9 ">
                                            <div class="checkbox">
                                                <label>
                                                    <input type="checkbox" value="{{ aggregator.id_pk }}"
                                                            {% if aggregator.store_relation %}
                                                           checked
                                                            {% endif %} name="aggregators">
                                                </label>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="control-label col-md-3 col-sm-3 col-xs-12"
                                               for="input-stablishment-number">
                                            Identificador
                                        </label>
                                        <div class="col-md-2 col-sm-2 col-xs-2">
                                            <input type="text" class="form-control" id="{{ aggregator.name }}_input_id"
                                                   placeholder="" name="{{ aggregator.name }}" accept=""
                                                    {% if not create and aggregator.relation_id %}
                                                   value="{{ aggregator.relation_id }}"
                                                    {% endif %}
                                            >
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="control-label col-md-3 col-sm-3">
                                            Credenciales de producción
                                        </label>
                                        <div class="col-md-6 col-sm-6">
                                            <input type="text" id="production-credentials-{{ aggregator.name }}"
                                                   name="production-credentials-{{ aggregator.name }}"
                                                    {% if not create and aggregator.production_credentials %}
                                                   value="{{ aggregator.production_credentials }}"
                                                    {% endif %}
                                                   class="form-control col-md-7 col-xs-12">
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="control-label col-md-3 col-sm-3 ">
                                            Credenciales de desarrollo
                                        </label>
                                        <div class="col-md-6 col-sm-6">
                                            <input type="text" id="develop-credentials-{{ aggregator.name }}"
                                                   name="develop-credentials-{{ aggregator.name }}"
                                                    {% if not create and aggregator.develop_credentials %}
                                                   value="{{ aggregator.develop_credentials }}"
                                                    {% endif %}
                                                   class="form-control col-md-7 col-xs-12">
                                        </div>
                                    </div>
                                {% endfor %}

                                <div class="form-group">
                                    <div class="col-md-6 col-sm-6 col-xs-12 col-md-offset-3">
                                        <button type="submit" class="btn btn-success">
                                            {% if create %} Registrar {% else %} Editar {% endif %}
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

{% block script %}
    <script>
        $("form").submit(function (event) {
            event.preventDefault();
            var post_url = $(this).attr("action");
            var request_method = $(this).attr("method");
            var form_data = $(this).serialize();

            $.ajax({
                url: post_url,
                type: request_method,
                data: form_data,
                success: function (json) {
                    window.location.replace('{% url 'administration:index' %}');
                },
                error: function (xhr, status, error) {
                    var json_error = JSON.parse(xhr.responseText);
                    console.log(json_error);
                    toastr[json_error.code](json_error.message, json_error.title);
                }
            });
        });
    </script>
{% endblock script %}